routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function ()
{
    return redirect()->route('login');
});

Route::middleware(['guest'])->group(function ()
{
    Route::get('forgot-password', 'ForgotPasswordController@showForgotPasswordForm');

    Route::post('forgot-password', 'ForgotPasswordController@sendMail')->name('forgot-password');

    Route::get('reset-password', 'ResetPasswordController@showResetPasswordForm');

    Route::post('reset-password', 'ResetPasswordController@reset')->name('password.reset');

    Route::get('login', 'AuthController@showLoginForm');

    Route::post('login', 'AuthController@authenticate')->name('login');
});

Route::middleware(['auth'])->group(function ()
{
    Route::post('logout', 'AuthController@logout')->name('logout');

    Route::get('dashboard', 'DashboardController')->name('dashboard.index');

    Route::name('dashboard.')->prefix('dashboard')->group(function()
    {
        Route::resource('unit', 'UnitController')->only('index', 'store');

        Route::prefix('p2h')->name('p2h.')->group(function()
        {
            Route::post('export-excel', 'P2HExportExcelController')->name('export-excel');

            Route::post('{firebaseId}/reminder', 'P2HReminderController')->name('reminder');

            Route::get('{firebaseId}/export-pdf', 'P2HExportPdfController')->name('export-pdf');

            Route::get('{firebaseId}/create-ticket', 'P2HCreateTicketController')->name('create-ticket');

            Route::get('{firebaseId}/export-ticket-pdf', 'P2HExportTicketPdfController')->name('export-ticket-pdf');
        });

        Route::resource('p2h', 'P2HController')->except('destroy');

        Route::prefix('report')->name('report.')->group(function()
        {
            Route::post('export-pdf', 'ReportExportPdfController')->name('export-pdf');

            Route::post('export-excel', 'ReportExportExcelController')->name('export-excel');
        });

        Route::resource('report', 'ReportController')->only('index');
    });
});

app/P2H.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class P2H extends Model
{
    protected $table = 'p2h';

    protected $guarded = ['id'];

    public function unit()
    {
        return $this->belongsTo(Unit::class, 'unit_id', 'id');
    }

    public function operator()
    {
        return $this->belongsTo(User::class, 'operator_id', 'id');
    }

    public function mekanik()
    {
        return $this->belongsTo(User::class, 'mekanik_id', 'id');
    }

    public function foreman()
    {
        return $this->belongsTo(User::class, 'foreman_id', 'id');
    }

    public function superintendent()
    {
        return $this->belongsTo(User::class, 'superintendent_id', 'id');
    }

    public function report()
    {
        return $this->hasOne(Report::class, 'p2h_id', 'id');
    }

    public function item()
    {
        return $this->hasMany(Item::class, 'p2h_id', 'id');
    }
}

app/Http/Controllers/DashboardController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class DashboardController extends Controller
{
    public function __invoke(Request $request)
    {
        return $this->index();
    }

    public function index()
    {
        return view('dashboard.index');
    }
}

app/Http/Controllers/P2HController.php
<?php

namespace App\Http\Controllers;

use App\Http\Traits\P2HVerificationTrait;
use App\Item;
use App\ListPemeriksaan;
use App\P2H;
use App\Report;
use App\Unit;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class P2HController extends Controller
{
    use P2HVerificationTrait;

    public function index(Request $request)
    {
        $startDate = $request->start_date ?? date('Y-m-01');
        $endDate = $request->end_date ?? date('Y-m-t');
        $data['start_date'] = $startDate . ' 00:00:00';
        $data['end_date'] = $endDate . ' 23:59:59';

        $data['list_p2h'] = P2H::with('unit')->where('jam', '>=', $data['start_date'])->where('jam', '<=', $data['end_date'])->orderByDesc('jam')->get();

        return view('dashboard.p2h.index', $data);
    }

    public function create(Request $request)
    {
        $data['unit'] = Unit::findOrFail($request->unit_id);
        $data['list_kategori'] = ['Pemeriksaan Keliling Unit/Diluar Kabin', 'Pemeriksaan Didalam Kabin', 'Pemeriksaan Di Ruang Mesin'];
        $data['list_pemeriksaan'] = ListPemeriksaan::get()->groupBy('kategori');

        return view('dashboard.p2h.create', $data);
    }

    public function store(Request $request)
    {
        $dataP2H = [
            'firebase_id' => $request->firebase_id,
            'unit_id' => $request->unit_id,
            'nomor_dokumen' => $request->nomor_dokumen,
            'jam' => date('Y-m-d H:i:s', strtotime($request->jam)),
            'hm_km' => $request->hm_km,
            'operator_id' => Auth::user()->id,
            'status' => 'Need Mechanic Verification',
            'created_at' => $request->current_time,
            'updated_at' => $request->current_time,
        ];
        $p2h = P2H::create($dataP2H);

        $dataListItem = $request->list_item;
        for ($i = 0; $i < count($dataListItem); $i++) {
            $item = $dataListItem[$i];
            $item['p2h_id'] = $p2h->id;
            $item['created_at'] = $request->current_time;
            $item['updated_at'] = $request->current_time;
            $dataListItem[$i] = $item;
        }
        Item::insert($dataListItem);

        $dataReport = [
            'p2h_id' => $p2h->id,
            'date_approve_operator' => $request->current_time,
            'status' => $p2h->status,
            'created_at' => $request->current_time,
            'updated_at' => $request->current_time,
        ];
        Report::create($dataReport);

        $this->sendVerificationNotificaton($p2h, $p2h->status, false);

        return redirect()->route('dashboard.p2h.index')->with('OK', 'Data berhasil disimpan');
    }

    public function show($firebaseId)
    {
        $data['p2h'] = P2H::with('unit', 'operator', 'mekanik', 'foreman', 'superintendent')->where('firebase_id', $firebaseId)->firstOrFail();
        $data['list_kategori'] = ['Pemeriksaan Keliling Unit/Diluar Kabin', 'Pemeriksaan Didalam Kabin', 'Pemeriksaan Di Ruang Mesin'];
        $data['list_pemeriksaan'] = Item::join('list_pemeriksaan', 'list_pemeriksaan.id', '=', 'item.list_pemeriksaan_id')->where('p2h_id', $data['p2h']->id)->get()->groupBy('kategori');

        return view('dashboard.p2h.show', $data);
    }

    public function edit($firebaseId)
    {

        $data['p2h'] = P2H::with('unit', 'operator', 'mekanik', 'foreman', 'superintendent')->where('firebase_id', $firebaseId)->firstOrFail();

        if (!$this->canVerify($data['p2h'])) {
            return redirect()->intended('dashboard/p2h')->with('ERR', 'Tidak dapat melakukan aksi tersebut');
        }

        $data['list_kategori'] = ['Pemeriksaan Keliling Unit/Diluar Kabin', 'Pemeriksaan Didalam Kabin', 'Pemeriksaan Di Ruang Mesin'];
        $data['list_pemeriksaan'] = Item::join('list_pemeriksaan', 'list_pemeriksaan.id', '=', 'item.list_pemeriksaan_id')->select('item.*', 'list_pemeriksaan.nama_pemeriksaan', 'list_pemeriksaan.kode_bahaya', 'list_pemeriksaan.kategori')->where('p2h_id', $data['p2h']->id)->get()->groupBy('kategori');

        return view('dashboard.p2h.edit', $data);
    }

    public function update(Request $request, $firebaseId)
    {
        $p2h = P2H::with('unit', 'report', 'operator', 'mekanik', 'foreman', 'superintendent')->where('firebase_id', $firebaseId)->firstOrFail();
        $p2h->update([
            'mekanik_id' => $request->mekanik_id ?? $p2h->mekanik_id,
            'foreman_id' => $request->foreman_id ?? $p2h->foreman_id,
            'superintendent_id' => $request->superintendent_id ?? $p2h->superintendent_id,
            'catatan' => $request->catatan,
            'status' => $request->status
        ]);

        Item::where('p2h_id', $p2h->id)->delete();
        Item::insert($request->list_item);

        $p2h->report->update([
            'date_approve_mekanik' => $request->mekanik_id != null ? $request->current_time : $p2h->report->date_approve_mekanik,
            'date_approve_foreman' => $request->foreman_id != null ? $request->current_time : $p2h->report->date_approve_foreman,
            'date_approve_superintendent' => $request->superintendent_id != null ? $request->current_time : $p2h->report->date_approve_superintendent,
            'status' => $request->status,
            'updated_at' => $request->current_time
        ]);

        $this->sendVerificationNotificaton($p2h, $request->status, false);

        return redirect()->route('dashboard.p2h.index')->with('OK', 'Data berhasil diperbarui');
    }
}

resources/views/dashboard/p2h/create.blade.php
@extends('layouts.layout2')

@section('title', 'Tambah P2H')

@push('style')
    <style>
        .list-type-upper-alpha
        {
            list-style-type: upper-alpha !important;
        }
    </style>
@endpush

@section('content_header')
    <div class="content-header row">
        <div class="content-header-left col-md-9 col-12 mb-2 d-md-block d-none">
            <div class="row breadcrumbs-top">
                <div class="col-12">
                    <h2 class="content-header-title float-left mb-0">Tambah P2H</h2>
                    <div class="breadcrumb-wrapper">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item">
                                <a href="{{ route('dashboard.index') }}">Beranda</a>
                            </li>
                            <li class="breadcrumb-item">
                                <a href="{{ route('dashboard.unit.index') }}">Unit</a>
                            </li>
                            <li class="breadcrumb-item active">Tambah P2H</li>
                        </ol>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('content')
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h3>Formulir P2H</h3>
                </div>
                <div class="card-body">
                    <form action="{{ route('dashboard.p2h.store') }}" method="post" id="form-create">
                        @csrf
                        <input type="hidden" name="unit_id" value="{{ request()->unit_id }}" id="input-unit-id">
                        <input type="hidden" name="firebase_id" id="input-firebase-id">
                        <input type="hidden" name="current_time" id="input-current-time">
                        <input type="hidden" name="nomor_dokumen" id="input-nomor-dokumen">
                        <div class="row form-group">
                            <div class="col-md-3">
                                <div class="form-group">
                                    <label for="">Unit</label>
                                    <input type="text" class="form-control" value="{{ $unit->no_unit }}" readonly id="input-no-unit">
                                </div>
                                <div class="form-group">
                                    <label for="">Jam</label>
                                    <input type="text" name="jam" class="form-control input-date-time" value="{{ date('Y-m-d H:i') }}" id="input-jam" required>
                                </div>
                                <div class="form-group">
                                    <label for="">Hm / Km</label>
                                    <input type="text" name="hm_km" class="form-control" id="input-hm-km" required>
                                </div>
                            </div>
                        </div>
                        <div class="form-group">
                            <table class="table table-bordered table-responsive d-block d-md-table">
                                <thead>
                                    <tr>
                                        <th style="width: 1%">No</th>
                                        <th style="width: 1%">PIC</th>
                                        <th>BAGIAN YANG HARUS DIPERIKSA</th>
                                        <th class="text-center" style="width: 1%">KODE<br>BAHAYA</th>
                                        <th class="text-center" style="width: 1%">KONDISI</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @php
                                        $indexCheckbox = 0;
                                    @endphp
                                    @foreach ($list_kategori as $indexKategori => $kategori)
                                        <tr>
                                            <th colspan="5" class="pl-0">
                                                <ol class="list-type-upper-alpha mb-0" start="{{ $indexKategori + 1 }}">
                                                    <li>{{ $kategori }}</li>
                                                </ol>
                                            </th>
                                        </tr>
                                        @php
                                            $no = 1;
                                        @endphp
                                        @foreach ($list_pemeriksaan[$kategori] as  $pemeriksaan)
                                            <tr>
                                                <td class="font-weight-bold">{{ $no }}</td>
                                                <td class="text-center">O/D</td>
                                                <td class="text-nowrap">{{ $pemeriksaan->nama_pemeriksaan }}</td>
                                                <td class="text-center">{{ $pemeriksaan->kode_bahaya }}</td>
                                                <td class="text-nowrap">
                                                    <input type="hidden" name="list_item[{{ $indexCheckbox }}][list_pemeriksaan_id]" value="{{ $pemeriksaan->id }}">
                                                    <div class="form-check form-check-inline">
                                                        <input type="radio" class="form-check-input" id="status-baik-{{ $indexCheckbox }}" name="list_item[{{ $indexCheckbox }}][status_checklist]" value="Baik/Normal" checked>
                                                        <label class="form-check-label" for="status-baik-{{ $indexCheckbox }}">Baik/Normal</label>
                                                    </div>
                                                    <div class="form-check form-check-inline">
                                                        <input type="radio" class="form-check-input" id="status-rusak-{{ $indexCheckbox }}" name="list_item[{{ $indexCheckbox }}][status_checklist]" value="Rusak/Tidak Normal">
                                                        <label class="form-check-label" for="status-rusak-{{ $indexCheckbox }}">Rusak/Tidak Normal</label>
                                                    </div>
                                                </td>
                                            </tr>
                                            @php
                                                $indexCheckbox++;
                                                $no++;
                                            @endphp
                                        @endforeach
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                        <div class="form-group text-right">
                            <button type="button" class="btn btn-primary px-3" id="btn-submit" disabled>Simpan</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('script')

    <script type="module">
        import { initializeApp } from "https://www.gstatic.com/firebasejs/9.8.3/firebase-app.js";
        import { getAnalytics } from "https://www.gstatic.com/firebasejs/9.8.3/firebase-analytics.js";
        import { getDatabase, ref, set, onValue, push, update, query, orderByKey, limitToLast } from "https://www.gstatic.com/firebasejs/9.8.3/firebase-database.js";

        // Declare variable from php
        const userId = @json(Auth::user()->id);
        const currentDate = @json(date('d-m-Y'));

        // Firebase configuration
        const firebaseConfig = {
            apiKey: "AIzaSyD8Fm1tbiwv2F3jVfhCLC3dg9zlY7HceyU",
            authDomain: "trisatria-trial.firebaseapp.com",
            databaseURL: "https://trisatria-trial-default-rtdb.asia-southeast1.firebasedatabase.app",
            projectId: "trisatria-trial",
            storageBucket: "trisatria-trial.appspot.com",
            messagingSenderId: "842562798000",
            appId: "1:842562798000:web:a76f064bd14f4276355675",
            measurementId: "G-XFJ3GNYP50"
        };

        // Initialize Firebase
        const app = initializeApp(firebaseConfig);
        const analytics = getAnalytics(app);
        const db = getDatabase();

        const p2hRef = ref(db, 'p2h');
        const indexState = query(p2hRef, orderByKey(), limitToLast(1));

        let firebaseId = 1;
        onValue(indexState, (snapshot) =>
        {
            if (snapshot.val() != null) {
                firebaseId = parseInt((Object.keys(snapshot.val())[0])) + 1;
            }
        });

        $(document).on("input", "input", function()
        {
            let jam = $("#input-jam").val();
            let hmKm = $("#input-hm-km").val();
            if (jam != "" && hmKm != "")
            {
                $("#btn-submit").prop("disabled", false);
            }else
            {
                $("#btn-submit").prop("disabled", true);
            }
        });

        $(document).on("click", "#btn-submit", function(e)
        {
            e.preventDefault();
            startLoading();
            const datetimeFormat = "YYYY-MM-DD HH:mm:ss";
            let now = moment();
            let currentTime = moment(now).format(datetimeFormat);
            $("#input-current-time").val(currentTime)
            $("#input-firebase-id").val(firebaseId);
            $("#input-nomor-dokumen").val('P2H/' + firebaseId + '/' + currentDate);

            const p2hRef = ref(db, 'p2h/' + firebaseId);
            let data = {
                unit_id: $("#input-unit-id").val(),
                no_unit: $("#input-no-unit").val(),
                nomor_dokumen: $("#input-nomor-dokumen").val(),
                jam: $("#input-jam").val(),
                hm_km: $("#input-hm-km").val(),
                operator_id: userId,
                mekanik_id: 0,
                foreman_id: 0,
                superintendent_id: 0,
                date_approve_operator: currentTime,
                date_approve_mekanik: 'out',
                date_approve_foreman: 'out',
                date_approve_superintendent: 'out',
                status: 'Need Mechanic Verification'
            }
            update(p2hRef, data).then(() => {
                $("#form-create").submit();
            });
        });

        $('.input-date-time').flatpickr({
            enableTime: true
        });
        $("a[href='{{ route('dashboard.p2h.index') }}']").closest(".nav-item").addClass("active");
    </script>
@endpush

resources/views/dashboard/p2h/index.blade.php
@extends('layouts.layout2')

@section('title', 'P2H')

@push('style')

@endpush

@section('content_header')
    <div class="content-header row">
        <div class="content-header-left col-md-9 col-12 mb-2 d-md-block d-none">
            <div class="row breadcrumbs-top">
                <div class="col-12">
                    <h2 class="content-header-title float-left mb-0">P2H</h2>
                    <div class="breadcrumb-wrapper">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item">
                                <a href="{{ route('dashboard.index') }}">Beranda</a>
                            </li>
                            <li class="breadcrumb-item active">P2H</li>
                        </ol>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('content')
    <div class="row">
        <div class="col-12">
            <form action="">
                <div class="row mb-2">
                    <div class="col-md-6 mb-1 mb-md-0">
                        <div class="row">
                            <div class="col-6">
                                <input type="date" name="start_date" class="form-control" value="{{ date('Y-m-d', strtotime($start_date)) }}" required>
                            </div>
                            <div class="col-6">
                                <input type="date" name="end_date" class="form-control" value="{{ date('Y-m-d', strtotime($end_date)) }}" required>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <button type="submit" class="btn btn-primary">Filter</button>
                        <button type="button" class="btn btn-success" id="btn-download-excel">Download Excel</button>
                    </div>
                </div>
            </form>
            <form action="{{ route('dashboard.p2h.export-excel') }}" method="post">
                @csrf
                <textarea name="list_p2h" class="d-none input-p2h">{{ $list_p2h }}</textarea>
                <button type="submit" class="d-none" id="btn-download-excel-hidden">Download Excel</button>
            </form>
            <div class="card">
                <div class="card-body">
                    <table class="table table-responsive d-block d-lg-table" id="table-p2h">
                        <thead>
                            <tr>
                                <th style="width: 1%">ID</th>
                                <th>UNIT</th>
                                <th>Nomor Dokumen</th>
                                <th>Status</th>
                                <th class="text-center" style="width: 1%">Aksi</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($list_p2h as $p2h)
                                <tr>
                                    <td>{{ $p2h->id }}</td>
                                    <td>{{ $p2h->unit->merk_unit }}</td>
                                    <td>{{ $p2h->nomor_dokumen }}</td>
                                    <td>{{ $p2h->status }}</td>
                                    <td>
                                        <div class="btn-group text-nowrap">
                                            <a href="{{ route('dashboard.p2h.show', $p2h->firebase_id) }}" class="btn btn-primary">Detail</a>

                                            @if (Auth::user()->role == 'mekanik' && $p2h->status == 'Need Mechanic Verification')
                                                <a href="{{ route('dashboard.p2h.edit', $p2h->firebase_id) }}" class="btn btn-info">Verifikasi P2H</a>
                                            @endif
                                            @if (Auth::user()->role == 'foreman' && ($p2h->status == 'Need Foreman Verification'))
                                                <a href="{{ route('dashboard.p2h.edit', $p2h->firebase_id) }}" class="btn btn-info">Verifikasi P2H</a>
                                            @endif
                                            @if (Auth::user()->role == 'foreman' && ($p2h->status == 'Need Ticket'))
                                                <a href="{{ route('dashboard.p2h.create-ticket', $p2h->firebase_id) }}" class="btn btn-warning">Create Ticket</a>
                                            @endif
                                            @if (Auth::user()->role == 'superintendent' && $p2h->status == 'Need Superintendent Verification')
                                                <a href="{{ route('dashboard.p2h.edit', $p2h->firebase_id) }}" class="btn btn-info">Verifikasi P2H</a>
                                            @endif
                                            @if ($p2h->status != 'Ticket Created' && $p2h->status != 'Completed')
                                                <a href="javascript:;" class="btn btn-danger btn-reminder" data-link="{{ route('dashboard.p2h.reminder', $p2h->firebase_id) }}">Reminder</a>
                                            @endif
                                            @if ($p2h->status == 'Ticket Created')
                                                <a href="{{ route('dashboard.p2h.export-ticket-pdf', $p2h->firebase_id) }}" class="btn btn-success btn-download-ticket">Download Ticket</a>
                                                <a href="javascript:;" class="btn btn-secondary btn-generate-link" data-link="{{ route('dashboard.p2h.export-ticket-pdf', $p2h->firebase_id) }}">Generate Link Ticket</a>
                                            @endif

                                        </div>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal-link">
        <div class="modal-dialog" style="width: 640px; max-width: 100%" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-sm-9 col-12">
                            <div class="form-group">
                                <input type="text" class="form-control" id="input-copy" value="Copy Me!" readonly>
                            </div>
                        </div>
                        <div class="col-sm-3 col-12">
                            <button class="btn btn-outline-primary btn-block waves-effect" id="btn-copy">Copy!</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal-reminder">
        <div class="modal-dialog" style="width: 640px; max-width: 100%" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Reminder</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form action="" method="post" id="form-reminder">
                        @csrf
                        <p>Tindakan ini akan mengirimkan email notifikasi reminder kepada yang bersangkutan, apakah Anda yakin?</p>
                        <div class="form-group mb-0 text-right">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Simpan</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

@push('script')

    <script>
        $(document).on("click", "#btn-download-excel", function()
        {
            $("#btn-download-excel-hidden").click();
        });

        $(document).on("click", ".btn-reminder", function()
        {
            let link = $(this).data("link");
            $("#form-reminder").prop("action", link);
            $("#modal-reminder").modal();
        });

        $(document).on("click", ".btn-download-ticket", function()
        {
            startLoading();
        });

        $(document).on("click", ".btn-generate-link", function()
        {
            let link = $(this).data("link");
            $("#input-copy").val(link);
            $("#modal-link").modal();
        });

        $(document).on("submit", "#form-reminder", function()
        {
            $("#modal-reminder").modal('hide');
            startLoading();
        });

        $(document).on("click", "#btn-copy", function () {
            $("#input-copy").select();
            document.execCommand("copy");
            toastr["success"]("", "Copied to clipboard!");
        });

        $("#table-p2h").DataTable();
        $("a[href='{{ route('dashboard.p2h.index') }}']").closest(".nav-item").addClass("active");
    </script>
@endpush